Crystal::Macros::StringLiteral -

# class Crystal::Macros::StringLiteral

- Crystal::Macros::StringLiteral
- Crystal::Macros::ASTNode
- Reference
- Object

## Overview

A string literal.

## Defined in:

## Instance Method Summary

- #+(other : StringLiteral | CharLiteral) : StringLiteral

  Similar to `String#+`.

- #<(other : StringLiteral | MacroId) : BoolLiteral

  Similar to `String#<`

- #=~(range : RegexLiteral) : BoolLiteral

  Similar to `String#=~`.

- #>(other : StringLiteral | MacroId) : BoolLiteral

  Similar to `String#>`

- #[](range : RangeLiteral) : StringLiteral

  Similar to `String#[]`.

- #camelcase : StringLiteral

  Similar to `String#camelcase`.

- #capitalize : StringLiteral

  Similar to `String#capitalize`.

- #chars : Crystal::Macros::ArrayLiteral(CharLiteral)

  Similar to `String#chars`.

- #chomp : StringLiteral

  Similar to `String#chomp`.

- #count(other : CharLiteral) : NumberLiteral

  Similar to `String#count`.

- #downcase : StringLiteral

  Similar to `String#downcase`.

- #empty? : BoolLiteral

  Similar to `String#empty?`.

- #ends_with?(other : StringLiteral | CharLiteral) : BoolLiteral

  Similar to `String#ends_with?`.

- #gsub(regex : RegexLiteral, replacement : StringLiteral) : StringLiteral

  Similar to `String#gsub`.

- #id : MacroId

  Returns a `MacroId` for this string's contents.

- #includes?(search : StringLiteral | CharLiteral) : BoolLiteral

  Similar to `String#includes?`.

- #lines : Crystal::Macros::ArrayLiteral(StringLiteral)

  Similar to `String#lines`.

- #size : NumberLiteral

  Similar to `String#size`.

- #split(node : ASTNode) : Crystal::Macros::ArrayLiteral(StringLiteral)

  Similar to `String#split`.

- #split : Crystal::Macros::ArrayLiteral(StringLiteral)

  Similar to `String#split`.

- #starts_with?(other : StringLiteral | CharLiteral) : BoolLiteral

  Similar to `String#starts_with?`.

- #strip : StringLiteral

  Similar to `String#strip`.

- #to_i(base = 10)

  Similar to `String#to_i`.

- #tr(from : StringLiteral, to : StringLiteral) : StringLiteral

  Similar to `String#tr`.

- #underscore : StringLiteral

  Similar to `String#underscore`.

- #upcase : StringLiteral

  Similar to `String#upcase`.

### Instance methods inherited from class `Crystal::Macros::ASTNode`

!=(other : ASTNode) : BoolLiteral !=, ==(other : ASTNode) : BoolLiteral ==, class_name : StringLiteral class_name, column_number : StringLiteral | NilLiteral column_number, end_column_number : StringLiteral | NilLiteral end_column_number, end_line_number : StringLiteral | NilLiteral end_line_number, filename : StringLiteral | NilLiteral filename, id : MacroId id, line_number : StringLiteral | NilLiteral line_number, raise(message) : NoReturn raise, stringify : StringLiteral stringify, symbolize : SymbolLiteral symbolize

### Instance methods inherited from class `Reference`

==(other : self)
==(other : JSON::Any)
==(other : YAML::Any)
==(other) ==, dup dup, hash(hasher) hash, inspect(io : IO) : Nil inspect, object_id : UInt64 object_id, pretty_print(pp) : Nil pretty_print, same?(other : Reference)
same?(other : Nil) same?, to_s(io : IO) : Nil to_s

### Constructor methods inherited from class `Reference`

new new

### Instance methods inherited from class `Object`

!=(other) !=, !~(other) !~, ==(other) ==, ===(other : JSON::Any)
===(other : YAML::Any)
===(other) ===, =~(other) =~, class class, dup dup, hash(hasher)
hash hash, inspect(io : IO) : Nil
inspect : String inspect, itself itself, not_nil! not_nil!, pretty_inspect(width = 79, newline = "\n", indent = 0) : String pretty_inspect, pretty_print(pp : PrettyPrint) : Nil pretty_print, tap(&block) tap, to_json(io : IO)
to_json to_json, to_pretty_json(indent : String = " ")
to_pretty_json(io : IO, indent : String = " ") to_pretty_json, to_s : String
to_s(io : IO) : Nil to_s, to_yaml(io : IO)
to_yaml to_yaml, try(&block) try, unsafe_as(type : T.class) forall T unsafe_as

### Constructor methods inherited from class `Object`

from_json(string_or_io, root : String) : self
from_json(string_or_io) : self from_json, from_yaml(string_or_io : String | IO) : self from_yaml

## Instance Method Detail

def +(other : StringLiteral | CharLiteral) : StringLiteral #

Similar to `String#+`.

def <(other : StringLiteral | MacroId) : BoolLiteral #

Similar to `String#<`

def =~(range : RegexLiteral) : BoolLiteral #

Similar to `String#=~`.

def >(other : StringLiteral | MacroId) : BoolLiteral #

Similar to `String#>`

def [](range : RangeLiteral) : StringLiteral #

Similar to `String#[]`.

def camelcase : StringLiteral #

Similar to `String#camelcase`.

def capitalize : StringLiteral #

Similar to `String#capitalize`.

def chars : Crystal::Macros::ArrayLiteral(CharLiteral) #

Similar to `String#chars`.

def chomp : StringLiteral #

Similar to `String#chomp`.

def count(other : CharLiteral) : NumberLiteral #

Similar to `String#count`.

def downcase : StringLiteral #

Similar to `String#downcase`.

def empty? : BoolLiteral #

Similar to `String#empty?`.

def ends_with?(other : StringLiteral | CharLiteral) : BoolLiteral #

Similar to `String#ends_with?`.

def gsub(regex : RegexLiteral, replacement : StringLiteral) : StringLiteral #

Similar to `String#gsub`.

def id : MacroId #

Returns a `MacroId` for this string's contents.

def includes?(search : StringLiteral | CharLiteral) : BoolLiteral #

Similar to `String#includes?`.

def lines : Crystal::Macros::ArrayLiteral(StringLiteral) #

Similar to `String#lines`.

def size : NumberLiteral #

Similar to `String#size`.

def split(node : ASTNode) : Crystal::Macros::ArrayLiteral(StringLiteral) #

Similar to `String#split`.

def split : Crystal::Macros::ArrayLiteral(StringLiteral) #

Similar to `String#split`.

def starts_with?(other : StringLiteral | CharLiteral) : BoolLiteral #

Similar to `String#starts_with?`.

def strip : StringLiteral #

Similar to `String#strip`.

def to_i(base = 10) #

Similar to `String#to_i`.

def tr(from : StringLiteral, to : StringLiteral) : StringLiteral #

Similar to `String#tr`.

def underscore : StringLiteral #

Similar to `String#underscore`.

def upcase : StringLiteral #

Similar to `String#upcase`.